import unittest
from argument import Argument
from literal import Literal


class TestArgument(unittest.TestCase):
    def test_basic(self):
        name: str = "a name"
        literal: Literal = Literal("literal")
        argument = Argument(name, literal)
        self.assertEqual(name, argument.name)
        self.assertEqual(literal, argument.expression)

    def test_to_xml(self):
        name: str = "a name"
        literal: Literal = Literal("literal")
        argument = Argument(name, literal)
        self.assertEqual(f'<argument name="{name}" expression="{literal}"/>', argument.to_xml())


if __name__ == '__main__':
    unittest.main()
