import unittest
from file_path import FilePath


class TestFilePath(unittest.TestCase):
    def test_case_insensitive(self):
        all_upper = "ALPHABET"
        all_lower = all_upper.lower()
        self.assertEqual(FilePath(all_upper), FilePath(all_lower))

    def test_redundant_separators(self):
        with_redundant_separator = "C:\\dir\\\\File.txt"
        without_redundant_separator = "C:\\dir\\File.txt"
        self.assertEqual(FilePath(with_redundant_separator), FilePath(without_redundant_separator))

    def test_navigation_same_insensitive(self):
        with_navigation = "C:\\dir\\.\\File.txt"
        without_navigation = "C:\\dir\\File.txt"
        self.assertEqual(FilePath(with_navigation), FilePath(without_navigation))

    def test_navigation_up_insensitive(self):
        with_navigation = "C:\\irrelevant\\..\\dir\\File.txt"
        without_navigation = "C:\\dir\\File.txt"
        self.assertEqual(FilePath(with_navigation), FilePath(without_navigation))


if __name__ == '__main__':
    unittest.main()
