import unittest
from file import File
from file_path import FilePath
from files import Files

file_path = FilePath("don't care")
file = File(file_path)


class TestFiles(unittest.TestCase):
    def test_initially_length_is_zero(self):
        files = Files()
        self.assertEqual(0, len(files))

    def test_add_file_makes_length_one(self):
        files = Files()
        files.add(file)
        self.assertEqual(1, len(files))

    def test_cannot_add_file_twice(self):
        files = Files()
        files.add(file)
        with self.assertRaises(Exception):
            files.add(file)


if __name__ == '__main__':
    unittest.main()
