import unittest

from expression import Expression
from file_path import FilePath
from file_position import FilePosition
from file_range import FileRange
from index_access import IndexAccess
from literal import Literal
from name import Name
from parameter import Parameter


class TestIndexAccess(unittest.TestCase):
    def test_index_access_is_expression(self):
        parameter = Parameter(Name("x"),
                              FilePath("A File path"),
                              FileRange(FilePosition(1, 1), FilePosition(2, 1))
                              )
        index_access = IndexAccess(parameter, [Literal("1")])
        self.assertIsInstance(index_access, Expression)

    def test_index_access_contains_expression(self):
        parameter = Parameter(Name("x"),
                              FilePath("A File path"),
                              FileRange(FilePosition(1, 1), FilePosition(2, 1))
                              )
        index_access = IndexAccess(parameter, [Literal("1")])
        self.assertTrue(index_access.contains_expression(index_access),
                        "Self containment expected")
        self.assertTrue(index_access.contains_expression(parameter),
                        "Subexpression containment expected")


if __name__ == '__main__':
    unittest.main()
