import unittest

from expression import Expression
from file_path import FilePath
from file_range import parse
from name import Name
from parameter import Parameter
from reference import Reference


class TestParameter(unittest.TestCase):
    parameter: Parameter

    def setUp(self) -> None:
        name: Name = Name("don't care")
        file_path = FilePath("a file path")
        file_range = parse("1:1-2:2")
        self.parameter = Parameter(name, file_path, file_range)

    def test_parameter_is_expression(self):
        self.assertIsInstance(self.parameter, Expression)

    def test_parameter_is_reference(self):
        self.assertIsInstance(self.parameter, Reference)

    def test_parameter_is_open(self):
        self.assertFalse(self.parameter.is_closed())


if __name__ == '__main__':
    unittest.main()
