import unittest

from file_path import FilePath
from file_range import parse
from name import Name
from parameter import Parameter
from variable import Variable


class TestReference(unittest.TestCase):
    def test_parameter_is_not_variable(self):
        name: Name = Name("don't care")
        file_path = FilePath("a file path")
        file_range = parse("1:1-2:2")
        parameter = Parameter(name, file_path, file_range)
        variable = Variable(name, file_path, file_range)
        self.assertNotEqual(parameter, variable)


if __name__ == '__main__':
    unittest.main()
