import unittest

from arguments import Arguments
from file_path import FilePath
from file_range import FileRange, parse
from name import Name
from parameter_declarations import ParameterDeclarations
from subprogram_declaration import SubprogramDeclaration


class TestSubprogramDeclaration(unittest.TestCase):
    def test_add_call_also_add_is_called_by(self):
        no_parameters = ParameterDeclarations()
        no_arguments = Arguments()
        assert no_arguments.match(no_parameters)

        a_name: Name = Name("a name")
        a_file_path: FilePath = FilePath("don't care")
        a_file_range: FileRange = parse("1:1-2:2")

        a_subprogram_declaration = SubprogramDeclaration(a_name,
                                                         a_file_path,
                                                         a_file_range,
                                                         no_parameters)
        another_name: Name = Name("another name")
        another_subprogram_declaration = SubprogramDeclaration(another_name,
                                                               a_file_path,
                                                               a_file_range,
                                                               no_parameters)
        assert 0 == len(another_subprogram_declaration.from_calls)
        assert 0 == len(a_subprogram_declaration.to_calls)
        another_subprogram_declaration.add_call(a_subprogram_declaration, no_arguments, a_file_range)
        self.assertEqual(1, len(another_subprogram_declaration.from_calls))
        self.assertEqual(1, len(a_subprogram_declaration.to_calls))


if __name__ == '__main__':
    unittest.main()
