import unittest

from expression import Expression
from file_path import FilePath
from file_range import parse
from name import Name
from reference import Reference
from variable import Variable


class TestVariable(unittest.TestCase):
    variable: Variable

    def setUp(self) -> None:
        name: Name = Name("don't care")
        file_path = FilePath("a file path")
        file_range = parse("1:1-2:2")
        self.variable = Variable(name, file_path, file_range)

    def test_variable_is_expression(self):
        self.assertIsInstance(self.variable, Expression)

    def test_variable_is_reference(self):
        self.assertIsInstance(self.variable, Reference)

    def test_variable_is_closed(self):
        self.assertTrue(self.variable.is_closed())


if __name__ == '__main__':
    unittest.main()
